import torch
import matplotlib.pyplot as plt
import numpy as np

#######################################################
# sigmoid regression by gradient descent              #
# zimmerk@fel.cvut.cz                                 #
# Vision for Robotics (VIR)                           #
#######################################################


# load points
N = 5
pts = np.load('pts.npy')
pts= torch.tensor(pts)
x,y = pts[:, 0], pts[:, 1]

# define optimization variables
w = torch.tensor([-2, 2], requires_grad=True, dtype=torch.double)
learning_rate = ...
for i in range(30):
    # OPTIMIZE WEIGHTS ...
    # (1) define loss
    # (2) compute gradient loss.backward()
    # (3) update weights
    f = ...
    loss = ...
    loss.backward()
    with torch.no_grad():
        w -= learning_rate * w.grad
    w.grad.zero_()

    # visualize result
    PTS = pts.detach().numpy() # convert to numpy
    W = w.detach().numpy()
    T = torch.linspace(-1, 1, 50).numpy()
    plt.figure(1), plt.clf()
    plt.plot(PTS[:, 0], PTS[:, 1], markersize=10, marker='x', color='r', linestyle='None')
    plt.plot(T, 1/(1+np.exp(-W[0] * T - W[1])), color='green')
    plt.xlabel('x')
    plt.ylabel('y')
    plt.pause(0.01)
    plt.draw()
